#extension GL_OES_texture_3D : enable
precision highp float;
varying highp vec2 textureCoordinate;
varying highp vec2 textureCoordinate2;
varying highp vec2 textureCoordinate3;
varying highp vec2 textureCoordinate4;

uniform sampler2D inputImageTexture;
uniform highp sampler3D inputImageTexture2;
uniform highp sampler3D inputImageTexture3;
uniform highp sampler3D inputImageTexture4;

uniform float w1;
uniform float w2;
uniform float w3;
uniform float intensity;

void main()
{
    float dimension = 33.0;

    vec4 color = texture2D(inputImageTexture, textureCoordinate.xy);
    vec3 dim = ((color.rgb * (dimension - 1.0) + 0.5))/dimension;

    vec4 destColor2 = texture3D(inputImageTexture2, dim);
    vec4 destColor3 = texture3D(inputImageTexture3, dim);
    vec4 destColor4 = texture3D(inputImageTexture4, dim);

    vec4 destColor = vec4(1.0);
    destColor.rgb = destColor2.rgb*w1 + destColor3.rgb*w2 + destColor4.rgb*w3;
    gl_FragColor = vec4(mix(color.rgb, destColor.rgb, intensity), color.a);
}