precision highp float;
varying highp vec2 textureCoordinate;
varying highp vec2 textureCoordinate2;
varying highp vec2 textureCoordinate3;
varying highp vec2 textureCoordinate4;

uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;
uniform sampler2D inputImageTexture3;
uniform sampler2D inputImageTexture4;

uniform float w1;
uniform float w2;
uniform float w3;
uniform float intensity;

vec4 lookup22(sampler2D texture, float intensity) {
    highp vec4 textureColor = texture2D(inputImageTexture, textureCoordinate);
    if (textureColor == vec4(0)) {
        return textureColor;
    }

    highp float blueColor = textureColor.b * 63.0;

    highp vec2 quad1;
    quad1.y = floor(floor(blueColor) / 8.0);
    quad1.x = floor(blueColor) - (quad1.y * 8.0);

    highp vec2 quad2;
    quad2.y = floor(ceil(blueColor) / 8.0);
    quad2.x = ceil(blueColor) - (quad2.y * 8.0);

    highp vec2 texPos1;
    texPos1.x = (quad1.x * 0.125) + 0.5 / 512.0 + ((0.125 - 1.0 / 512.0) * textureColor.r);
    texPos1.y = (quad1.y * 0.125) + 0.5 / 512.0 + ((0.125 - 1.0 / 512.0) * textureColor.g);

    highp vec2 texPos2;
    texPos2.x = (quad2.x * 0.125) + 0.5 / 512.0 + ((0.125 - 1.0 / 512.0) * textureColor.r);
    texPos2.y = (quad2.y * 0.125) + 0.5 / 512.0 + ((0.125 - 1.0 / 512.0) * textureColor.g);

    lowp vec4 newColor1 = texture2D(texture, texPos1);
    lowp vec4 newColor2 = texture2D(texture, texPos2);

    lowp vec4 newColor = mix(newColor1, newColor2, fract(blueColor));
    return mix(textureColor, vec4(newColor.rgb, textureColor.w), textureColor.a*intensity);
}

void main()
{
    float dimension = 33.0;

    vec4 color = texture2D(inputImageTexture, textureCoordinate.xy);
    vec3 dim = color.rgb*dimension;

    float x = dim.x;
    float y = dim.y;
    float z = (dim.x + dim.y*dimension + dimension*dimension*dim.z)/dimension/dimension;

    vec4 destColor2 = texture2D(inputImageTexture2, textureCoordinate2);
    vec4 temp = texture2D(inputImageTexture2, vec2(z, y));
    destColor2 = lookup22(inputImageTexture2, w1);//mix(destColor2, temp, fract(dim.r));// fract(dim.r)*temp + (1.0 - fract(dim.r))*destColor2;

    vec4 destColor3 = texture2D(inputImageTexture3, textureCoordinate);
    //temp = texture2D(inputImageTexture3, vec2(z, y));
    //destColor3 = mix(destColor3, temp, 0.5);//vec4(destColor3.x, destColor3.y, temp.x, temp.z);
    //destColor3.a = 1.0;
    destColor3 = lookup22(inputImageTexture3, w2);

    vec4 destColor4 = texture2D(inputImageTexture4, textureCoordinate);
    //temp = texture2D(inputImageTexture4, vec2(z, y));
    //destColor4 = mix(destColor4, temp, 0.5);//vec4(destColor4.x, destColor4.y, temp.x, temp.z);
    //destColor4.a = 1.0;
    destColor4 = lookup22(inputImageTexture4, w3);

    vec4 destColor = vec4(1.0);
    destColor.rgb = destColor2.rgb + destColor3.rgb + destColor4.rgb;
    gl_FragColor = vec4(mix(color.rgb, destColor.rgb, intensity), color.a);
}